require 'rubygems'

require 'bundler/setup' if ENV['BUNDLE_GEMFILE'] && File.exist?(ENV['BUNDLE_GEMFILE'])

require 'thread'
require 'monitor'
require 'syslog'
require 'timeout'
require 'logger'

require 'active_support'
require 'active_support/inflector'
require 'active_support/core_ext/hash'
require 'active_support/core_ext/numeric'
require 'active_support/duration'

require 'bluepill/dsl/process_proxy'
require 'bluepill/dsl/process_factory'
require 'bluepill/dsl/app_proxy'

require 'bluepill/application'
require 'bluepill/controller'
require 'bluepill/socket'
require 'bluepill/process'
require 'bluepill/process_statistics'
require 'bluepill/group'
require 'bluepill/logger'
require 'bluepill/condition_watch'
require 'bluepill/trigger'
require 'bluepill/triggers/flapping'
require 'bluepill/dsl'
require 'bluepill/system'

require 'bluepill/process_conditions'

require 'bluepill/util/rotational_array'

require 'bluepill/version'
